/*
coding by Kwynn Buess of Kwynn.com
idea (given to me) by Stephen L. Brown of BizGenie.net
other credits near bottom

2011/09/15 - CHANGES: 

Creating version 1.1.0.  The previous version was 1.0.5.  

In version 1.1.0, I'm removing references to the social networking site in question, due to 
their fussing about trademarks.  If it wasn't clear before, this AddOn is not endorsed by 
the social networking site in question.  

Previous version history near bottom.

********

*/

var counter_kwynn_com = {

VERSION : "1.1.0", 
DEBUG : false,
KEY_DEBUG : false,
MAX_CHARS_STATUS : 500,
MAX_CHARS_QUESTION: 170,
OUTPUT_DIV_FOUND : false,
count : 0,
ourDiv : false,
statusInputObj : false,
questionInputObj: false,
theDoc: false,
plural: true,
under: true,
loc_key_cnt : 0,
doc_key_cnt : 0,

/* The escapeHTML function just below comes almost verbatim from the AMO (addons.mozilla.org) Editors in reponse to the 
submission of this AddOn for "full review."  You can see this function at 
https://wiki.mozilla.org/AMO:Editors/MiscCannedResponses  */

// The following line is exactly what the AMO Editors sent.  
//   function escapeHTML(str) str.replace(/[&"<>]/g, function (m) "&" + ({ "&": "amp", '"': "quot", "<": "lt", ">": "gt" })[m] + ";");

// I had to modify it just slightly for whatever this syntax is called -- class syntax or whatever.  ("name : function" rather 
// than "function name" -- whatever this is called)
escapeHTML : function(str) { 
	
	str += ""; // forces a number (such as 420) to a string, othewise str.replace throws an error
	return str.replace(/[&"<>]/g, function (m) "&" + ({ "&": "amp", '"': "quot", "<": "lt", ">": "gt" })[m] + ";");
},

chrome_level_listener : function()
{
    var appcontent = document.getElementById("appcontent");   // appcontent = browser, as opposed to mailer or such
    if(appcontent)
      appcontent.addEventListener("load", counter_kwynn_com.myLoad, true);
}, 

myLoad: function(event)
{	 
	if (event.target == undefined) return;
	if (event.target.URL == undefined) return;


	if (counter_kwynn_com.DEBUG) Components.utils.reportError('Counter - url = ' + event.target.URL.substr(0,40));


	// KB 2011/07/07 - see comments at top: search to indexOf and using == rather than < or >
	if (
			event.target.URL == "http://www.facebook.com/"
		|| 	event.target.URL == "https://www.facebook.com/"

	) 
	{
		if (counter_kwynn_com.DEBUG) 
			Components.utils.reportError('Counter - found site, otar = ' +
			event.target + "wrap = " + event.target.wrappedJSObject);		

		counter_kwynn_com.theDoc = event.target.wrappedJSObject;

		counter_kwynn_com.findStatus(event.target.wrappedJSObject);

		event.target.wrappedJSObject.addEventListener("input", counter_kwynn_com.docKeyPress, false);

	}

},

getParentDoc : function (node) { 
	if (node == null || node == undefined) {
		if (counter_kwynn_com.DEBUG) Components.utils.reportError('Counter - null node in getParentDoc');
		return undefined;
	}

	var tempNode;
	if (node instanceof HTMLDocument) return node;
	else return counter_kwynn_com.getParentDoc(node.parentNode);
},

docKeyPress : function (event) { 

	if (event.type == 'input') 
	{ 
		counter_kwynn_com.doc_key_cnt++;
		if (counter_kwynn_com.KEY_DEBUG) 
			Components.utils.reportError('doc cnt = ' + counter_kwynn_com.doc_key_cnt);	
	}
	
	if (counter_kwynn_com.doc_key_cnt == counter_kwynn_com.loc_key_cnt) { 
		if (counter_kwynn_com.KEY_DEBUG) Components.utils.reportError('count match');	
		return;
	}


	if (counter_kwynn_com.KEY_DEBUG) Components.utils.reportError('Counter - doc-level event');

	var theDoc = counter_kwynn_com.getParentDoc(event.target.wrappedJSObject);

	counter_kwynn_com.findStatus(theDoc);
	counter_kwynn_com.findDiv(theDoc);
	counter_kwynn_com.loc_key_cnt = 0;
	counter_kwynn_com.doc_key_cnt   = 0;
},

ourCount : function (event)
{



	counter_kwynn_com.loc_key_cnt = 0;
	counter_kwynn_com.doc_key_cnt   = 0;

	if (event.type == 'input')
	{ 
		++counter_kwynn_com.loc_key_cnt;
		if (counter_kwynn_com.KEY_DEBUG) 
			Components.utils.reportError('loc key = ' + counter_kwynn_com.loc_key_cnt);	
	}

	if (counter_kwynn_com.KEY_DEBUG) Components.utils.reportError('Counter - local event');

	if (counter_kwynn_com.theDoc == false) return;	

	try {

		var outID = counter_kwynn_com.theDoc.getElementById('kwynn_com_bg_20110317_count');

		if (outID == undefined || outID == null)  			
			counter_kwynn_com.findDiv();	

		if (counter_kwynn_com.statusInputObj == undefined && counter_kwynn_com.questionInputObj == undefined) 
		{ 
			if (counter_kwynn_com.DEBUG) Components.utils.reportError('Counter - inputObj undef');

			return;

		}


		var myLen = event.target.wrappedJSObject.value.length;


		var myDiff;
		if (event.target.wrappedJSObject == counter_kwynn_com.statusInputObj) myDiff = 
			counter_kwynn_com.MAX_CHARS_STATUS - myLen;
		else myDiff = counter_kwynn_com.MAX_CHARS_QUESTION - myLen;

		if (myDiff < 0 && counter_kwynn_com.under == true) { 
			counter_kwynn_com.theDoc.getElementById('kwynn_com_text_20110317').innerHTML = "over the limit";

			counter_kwynn_com.theDoc.getElementById('kwynn_com_20110317_outer').style.color = "#ED1414";

			counter_kwynn_com.under = false;
		}
		else if (myDiff >= 0 && counter_kwynn_com.under == false) {
			counter_kwynn_com.theDoc.getElementById('kwynn_com_text_20110317').innerHTML = "left";

			counter_kwynn_com.theDoc.getElementById('kwynn_com_20110317_outer').style.color = "#3B5998";
			counter_kwynn_com.under = true;
		}

		if ((myDiff == 1 || myDiff == -1) && counter_kwynn_com.plural) 
		{
				counter_kwynn_com.theDoc.getElementById('kwynn_com_sing_20110317').innerHTML = "";
				 counter_kwynn_com.plural = false;
		} else {

			counter_kwynn_com.theDoc.getElementById('kwynn_com_sing_20110317').innerHTML = "s";
			counter_kwynn_com.plural = true;

		}

		myDiff = Math.abs(myDiff);

		counter_kwynn_com.theDoc.getElementById('kwynn_com_bg_20110317_count').innerHTML = 
			counter_kwynn_com.escapeHTML(myDiff);

		if (counter_kwynn_com.KEY_DEBUG) 
			Components.utils.reportError("count HTML = " + 
				counter_kwynn_com.theDoc.getElementById('kwynn_com_bg_20110317_count').innerHTML);


	}
	catch(e) { 
		if (counter_kwynn_com.KEY_DEBUG) 
			Components.utils.reportError('Counter ourCount() exception.  e = ' + e);

		counter_kwynn_com.findDiv();
	}
	
},

findDiv: function() {

	if (counter_kwynn_com.DEBUG) 
		Components.utils.reportError('counter - in findDiv()');

	if (counter_kwynn_com.theDoc != undefined)
	if (	counter_kwynn_com.theDoc.getElementById('kwynn_com_bg_20110317_count') != undefined && 
		counter_kwynn_com.theDoc.getElementById('kwynn_com_bg_20110317_count') != null
	) return;

	
	var diva = counter_kwynn_com.theDoc.getElementsByTagName('div');
	
	if (counter_kwynn_com.DEBUG) 
		Components.utils.reportError('counter - div count = ' + diva.length);

	var count = 0;
	for (var i=0; i < diva.length; i++) 
	{

		// KMB 2011/08/31 - OR attachementBarArea
		if (
			(		diva[i].className.search(/showOnceInteracted/) >= 0
				&& 	diva[i].className.search(/uiComposerMessageBoxControls/) >= 0
			) || 
					diva[i].className.search(/attachmentBarArea/) >= 0
		) 
		{ 
			if (counter_kwynn_com.DEBUG) 
				Components.utils.reportError('counter - found output div - v');
			counter_kwynn_com.OUTPUT_DIV_FOUND = true;

			var newP = counter_kwynn_com.theDoc.createElement('p');
			newP.style.display = 'inline';
			
			newP.innerHTML = 
				"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; " +
				"<span style='color: #3B5998; font-weight: bold' id='kwynn_com_20110317_outer'>" + 
					"<span id='kwynn_com_bg_20110317_count' >" + 
						counter_kwynn_com.escapeHTML(counter_kwynn_com.MAX_CHARS_STATUS) + 
						"</span> " + "character" + 
						"<span id='kwynn_com_sing_20110317'>s</span>" + " " +
					"<span id='kwynn_com_text_20110317'>left</span>"
						 + "</span>" 
					;

			diva[i].appendChild(newP);

			if (counter_kwynn_com.DEBUG) 
				Components.utils.reportError('counter - found output div');

			return true;
			
		}
	}

	return false;
},

findStatus : function(docIN) { 

	if (docIN == undefined) 
		if (counter_kwynn_com.DEBUG) 
			Components.utils.reportError('Counter - undefined doc sent to findStatus');
	if (docIN == undefined) return false;

	var texta = docIN.getElementsByTagName('textarea');

	if (counter_kwynn_com.DEBUG) Components.utils.reportError('Counter - in findstatus');

	for (var i=0; i < texta.length; i++) 
	{

		if (counter_kwynn_com.DEBUG) Components.utils.reportError('Counter - in fs loop');
	
		var tempObj = texta[i];
		var taClass = texta[i].className;
		
// uiTextareaAutogrow input mentionsTextarea textInput

		if (taClass != undefined) {
		
		if (counter_kwynn_com.DEBUG) Components.utils.reportError('ta class name = ' + taClass);

		if (	
			(
				taClass.search(/uiTextareaAutogrow/) >= 0 && 
				taClass.search(/input/) >= 0 &&
				taClass.search(/mentionsTextarea/) >= 0 &&
				taClass.search(/textInput/) >= 0
			) ||
			(
				taClass.search(/uiTextareaNoResize/) >= 0 &&
				taClass.search(/uiTextareaAutogrow/) >= 0 &&
				taClass.search(/questionInput/)      >= 0 &&
				taClass.search(/fluidInput/)         >= 0
			)

			
		) {

			if (counter_kwynn_com.DEBUG) Components.utils.reportError('Counter - found input div - ID = ' + tempObj + ' - v' + this.VERSION);

			var maxCountSpan = docIN.getElementById('kwynn_com_bg_20110317_count');


			if (taClass.search(/textInput/) >= 0) {
				counter_kwynn_com.statusInputObj  	= tempObj;
				if (maxCountSpan != undefined)
					maxCountSpan.innerHMTL = counter_kwynn_com.MAX_CHARS_STATUS;
			}
			else {
				counter_kwynn_com.questionInputObj  = tempObj;
				if (maxCountSpan != undefined)
					maxCountSpan.innerHMTL = counter_kwynn_com.MAX_CHARS_QUESTION;

			}

			counter_kwynn_com.theDoc 	= docIN;
			counter_kwynn_com.addListeners(tempObj);
			counter_kwynn_com.findDiv();

			return true;
		} // if className matches

	} // if className defined
	} // end for loop for looping through textareas

	return false;

}, // end function

addListeners : function(object)
{
	object.addEventListener('input', counter_kwynn_com.ourCount, false);
}


}; // end object


if (counter_kwynn_com.DEBUG) 
	Components.utils.reportError('Counter - hello world - very first - v' + counter_kwynn_com.VERSION);


window.addEventListener("load", counter_kwynn_com.chrome_level_listener, false);


/* 

On 2011/05/24, as of version 0.3.6, I'm removing some of the notes and version history.  
This older text exist in previous versions that are on Firefox's AddOn site and my web site (kwynn.com).


***** CREDITS ******

Stephen L. Brown of BizGenie.net gave me the idea.  
Stephen also introduced me to the Firebug Firefox AddOn by Joe Hewitt.  That speeded development quite a bit.  
Stephen dictated the style--color and placement of my output box.

My sister, Kyleigh Buess, helped debug 0.2.5 so I could improve to 0.3.0.  

Will McSweeney of BizGenie.net pointed out that it's keyup, not keypress.  


****** RECENT CHANGE HISTORY (earlier history below) *******

2011/08/31 - TODAY'S FIXES, for version 1.0.0.1dev and beyond
(fixes 1 - 5 done early in the morning for v1.0.1 and 1.0.2, number 6 late at night, for v1.0.3)

1. using the "input" event instead of "keyup," "click," "cut," and "paste," per the AMOEs' suggestion.  
2. The target site changed the class name for output when you're on someone else's page--had to fix.
3. I was getting exceptions around the the various output fields, so I added some handlers to make 
	findDiv() run again when this happens.
4. Make the target site URL == (precise match) rather than match a partial URL
5. 500 char limit rather than 420
6. I think it happend during the changes between 1.0.0 and 1.0.3 (non-inclusive), but I was using "document"
   rather than "...theDoc..." in the first few lines of findDiv.  This caused quite a bit of junk output 
   where "500 characters" appeared over and over when people used chat (not status).

2011/09/01
- added 3 &nbsp; to output (v1.0.4)

2011/09/01 - later in the day
- moved a few more spaces to the right (v1.0.5)

***** VERSION HISTORY *****

2011/07/07 - In the URL filters, change search to indexOf and > -1 to == 0, per the round of AMOE comments 
	received today, for v0.4.2.

2011/06/17 - removed anything conceivably interpreted as an ad, per AMOE, for v0.3.8.

2011/06/15 - applying escapeHTML() function per AMO Editor's comments, for v0.3.7.

2011/05/24 - adding HTTPS in addition to HTTP in response to users' comments, for v0.3.6

-- version 0.3.5 - added target-site "Question" counter

-- version 0.0.4 - first stable version; solved the serious reliability problem on Kwynn's computer (3:00am)
very first version created March 17, 2011, ca. 12:30am EDT (00:30, USA, GMT -4)


*/

